package com.zhongzheng.modules.goods.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.goods.bo.GoodsAttachedAddBo;
import com.zhongzheng.modules.goods.bo.GoodsAttachedEditBo;
import com.zhongzheng.modules.goods.bo.GoodsAttachedQueryBo;
import com.zhongzheng.modules.goods.domain.GoodsAttached;
import com.zhongzheng.modules.goods.mapper.GoodsAttachedMapper;
import com.zhongzheng.modules.goods.mapper.GoodsMapper;
import com.zhongzheng.modules.goods.service.IGoodsAttachedService;
import com.zhongzheng.modules.goods.vo.GoodsAttachedVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 商品附加产品Service业务层处理
 *
 * @author  hjl
 * @date 2021-10-28
 */
@Service
public class GoodsAttachedServiceImpl extends ServiceImpl<GoodsAttachedMapper, GoodsAttached> implements IGoodsAttachedService {


    @Autowired
    private GoodsAttachedMapper goodsAttachedMapper;

    @Override
    public GoodsAttachedVo queryById(Long id){
        GoodsAttached db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, GoodsAttachedVo.class);
    }

    @Override
    public List<GoodsAttachedVo> selectDoList(GoodsAttachedQueryBo bo) {
        return goodsAttachedMapper.selectDoList(bo);
    }

    @Override
    public List<GoodsAttachedVo> queryList(GoodsAttachedQueryBo bo) {
        LambdaQueryWrapper<GoodsAttached> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getGoodsId() != null, GoodsAttached::getGoodsId, bo.getGoodsId());
        lqw.eq(bo.getMajorId() != null, GoodsAttached::getMajorId, bo.getMajorId());
        lqw.eq(bo.getSort() != null, GoodsAttached::getSort, bo.getSort());
        lqw.eq(bo.getType() != null, GoodsAttached::getType, bo.getType());
        return entity2Vo(this.list(lqw));
    }

    @Override
    public List<GoodsAttachedVo> selectList(GoodsAttachedQueryBo bo) {
        return goodsAttachedMapper.selectList(bo);
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<GoodsAttachedVo> entity2Vo(Collection<GoodsAttached> collection) {
        List<GoodsAttachedVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, GoodsAttachedVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<GoodsAttached> page = (Page<GoodsAttached>)collection;
            Page<GoodsAttachedVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(GoodsAttachedAddBo bo) {
        GoodsAttached add = BeanUtil.toBean(bo, GoodsAttached.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(GoodsAttachedEditBo bo) {
        GoodsAttached update = BeanUtil.toBean(bo, GoodsAttached.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(GoodsAttached entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
